viDraw = {};

function viDraw:setOpenAnimals(self)
	local iconAnimalHeight = viGui.buttonGfxHeight1*3.5*5;
	local iconAnimalWidth = viGui.buttonGfxWidth1*3.5*6;
	--local sizeHeightBig = getTextHeight(viGui.buttonGfxHeight1*3.5*3, "100%");
	--local lenghtTxt = getTextWidth(sizeHeightBig, "100%");
	local helpTxt = "";
	local distance = 0.003
	local animalsWidth = 0;
	local posX = viGui.defaultHud.seeAnimals.posX;
	local posY = viGui.defaultHud.seeAnimals.posY-iconAnimalHeight;
	viGui.defaultHud.clickAreaAnimals = {};	
	if g_currentMission.husbandries ~= nil then		
		local dragDrop = false;
		if viGui.settingsGuiMenue.on and viGui.defaultHud.timer["isTimer0"] > viGui.defaultHud.timer["timer0"]/2 and not viGui.settingsOnViMenue.dragDropPos and not viGui.defaultHud.seeAnimals.defaultPos then
			viGui:setOverlay(self, viGui["newPosMouse"], posX+animalsWidth, posY, iconAnimalWidth, iconAnimalHeight);
			viGui["newPosMouse"]:render();
			helpTxt = "press left mouse\nset new Position";
			dragDrop = true;
		end;
		if viGui.defaultHud.seeAnimals.chicken and g_currentMission.husbandries.chicken ~= nil then
			if dragDrop then 
				dragDrop = false; 
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, "seeAnimals", what="chicken", getTxt=tostring(helpTxt)};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			else
				viGui:setOverlay(self, viGui["chicken"], posX+animalsWidth, posY, false, false);
				viSetGet:setGetNumberColor(self, g_currentMission.husbandries.chicken.productivity, 100, false, false, "chicken", "animal");
				viGui["chicken"]:render();
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, animal=g_currentMission.husbandries.chicken, what="chicken", getTxt=tostring(g_currentMission.husbandries.chicken.totalNumAnimals).. " Chicken: ".. tostring(string.format("%1.0f", Utils.getNoNil(g_currentMission.husbandries.chicken.productivity*100, 0))).. "%"};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			end;
		end;
		if viGui.defaultHud.seeAnimals.pig and g_currentMission.husbandries.pig ~= nil then
			if dragDrop then 
				dragDrop = false;
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, "seeAnimals", what="pig", getTxt=tostring(helpTxt)};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			else
				viGui:setOverlay(self, viGui["pig"], posX+animalsWidth, posY, false, false);
				viSetGet:setGetNumberColor(self, g_currentMission.husbandries.pig.productivity, 100, false, false, "pig", "animal");
				viGui["pig"]:render();
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, animal=g_currentMission.husbandries.pig, what="pig", getTxt=tostring(g_currentMission.husbandries.pig.totalNumAnimals).. " Pig: ".. tostring(string.format("%1.0f", Utils.getNoNil(g_currentMission.husbandries.pig.productivity*100, 0))).. "%"};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			end;
		end;
		if viGui.defaultHud.seeAnimals.cow and g_currentMission.husbandries.cow ~= nil then
			if dragDrop then 
				dragDrop = false;
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, "seeAnimals", what="cow", getTxt=tostring(helpTxt)};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			else
				viGui:setOverlay(self, viGui["cow"], posX+animalsWidth, posY, false, false);
				viSetGet:setGetNumberColor(self, g_currentMission.husbandries.cow.productivity, 100, false, false, "cow", "animal");
				viGui["cow"]:render();
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, animal=g_currentMission.husbandries.cow, what="cow", getTxt=tostring(g_currentMission.husbandries.cow.totalNumAnimals).. " Cow: ".. tostring(string.format("%1.0f", Utils.getNoNil(g_currentMission.husbandries.cow.productivity*100, 0))).. "%"};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			end;
		end;
		if viGui.defaultHud.seeAnimals.sheep and g_currentMission.husbandries.sheep ~= nil then
			if dragDrop then 
				dragDrop = false;
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, "seeAnimals", what="sheep", getTxt=tostring(helpTxt)};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			else
				viGui:setOverlay(self, viGui["sheep"], posX+animalsWidth, posY, false, false);
				viSetGet:setGetNumberColor(self, g_currentMission.husbandries.sheep.productivity, 100, false, false, "sheep", "animal");
				viGui["sheep"]:render();
				viGui.defaultHud.clickAreaAnimals[#viGui.defaultHud.clickAreaAnimals+1] = {posX+animalsWidth, posX+animalsWidth+iconAnimalWidth, posY, posY+iconAnimalHeight, animal=g_currentMission.husbandries.sheep, what="sheep", getTxt=tostring(g_currentMission.husbandries.sheep.totalNumAnimals).. " Sheep: ".. tostring(string.format("%1.0f", Utils.getNoNil(g_currentMission.husbandries.sheep.productivity*100, 0))).. "%"};
				animalsWidth = animalsWidth+iconAnimalWidth+distance;
			end;
		end;
		--viGui.defaultHud.seeAnimals.dragDropGround = {width=animalsWidth+iconAnimalWidth+distance, height=iconAnimalHeight};
		viGui.defaultHud.seeAnimals.width=animalsWidth;
		viGui.defaultHud.seeAnimals.height=iconAnimalHeight;
	end;
end;

function viDraw:setOpenPDA(self)
	viSetGet:setVehicles(self);
	viExtras:setTimers(self);
	viGui.defaultHud.clickArea = {};
	viGui.settingsOnViMenue.clickArea = {};
	viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter = 0;
	if (viGui.defaultHud.seeGlobalWarningIcon and not g_currentMission.vi.isHidden) or (g_currentMission.vi.isHidden and g_currentMission.vi.hiddenWarnings) then
		if viGui.defaultHud.seeGlobalWarningVehicle and viGui.defaultHud.seeGlobalWarningVehicleAutoOff and not viGui.defaultHud.seeGlobalWarningVehicleAutoOnHidden then
			viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer = viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer+1;			
			if viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeGlobalWarningVehicleAutoOffTimer]/2 then
				viGui.defaultHud.seeGlobalWarningVehicle = false;
				viGui.defaultHud.seeGlobalWarningVehicleAutoOffIsTimer = 0;
				if viGui.defaultHud.seeGlobalWarningVehicleOldHidden then
					g_currentMission.vi.isHidden = viGui.defaultHud.seeGlobalWarningVehicleOldHidden;
				end;
			else
				
			end;		
		end;
	end;
	local distanceFix1 = 0.001;
	local distanceFix2 = 0.002;
	local distanceFix2_5 = 0.0025;
	local distanceFix3 = 0.003;	
	local distanceFix4 = 0.004;
	local sizeHeightSmall = getTextHeight(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*2.7, "----Test----");
	local sizeHeightMiddle = getTextHeight(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*2.9, "----Test----");
	local sizeHeightBig = getTextHeight(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3, "----Test----");	
	local iconHeight = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4;
	local iconMenueHeight = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5;
	local height = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8;
	local height2 = height/2;
	local height3 = height/3;
	local height4 = height/4;
	local width = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*(9+viGui.defaultHud.distanceAttachedStretch);
	local iconWidth = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5;
	local iconMenueWidth = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6;
	local upDisplay = false;	
	local posX = viGui.defaultHud.posX;
	local posY = viGui.defaultHud.posY-height;
	if viGui.settingsOnViMenue.isLockDefaultHud then posY = viGui.defaultHud.posY-height-(iconMenueHeight/2);end;
	if viGui.defaultHud.pos == 4 or viGui.defaultHud.pos == 5 or viGui.defaultHud.pos == 6 then upDisplay = true;posY = viGui.defaultHud.posY;end;
	local firstPosX = posX;
	local firstPosY = posY;	
	local sortByGroup = VehicleInspector.foundGroupManager and viGui.defaultHud.sortBy.isGroup;	
			
	viDraw:setViMenue(self, distanceFix1, distanceFix2, distanceFix2_5, distanceFix3, distanceFix4, sizeHeightSmall, sizeHeightMiddle, sizeHeightBig, iconHeight, iconMenueHeight, height, height2, height3, height4,
		width, iconWidth, iconMenueWidth, posX, posY, firstPosX, firstPosY, sortByGroup, upDisplay);
	if viGui.defaultHud.design == 1 and viGui.defaultHud.seeTrailerLine == 2 then
		if (viGui.defaultHud.pos == 3 and getIngameHelpMenu() and g_currentMission.ingameMap.state ~= 0) or (viGui.defaultHud.pos == 6 and g_currentMission.ingameMap.state == 0) then return;end;
		viDraw:loadDesign1(self, distanceFix1, distanceFix2, distanceFix2_5, distanceFix3, distanceFix4, sizeHeightSmall, sizeHeightMiddle, sizeHeightBig, iconHeight, iconMenueHeight, height, height2, height3, height4,
		width, iconWidth, iconMenueWidth, posX, posY, firstPosX, firstPosY, sortByGroup, upDisplay);		
	end;
end;

function viDraw:setViMenue(self, distanceFix1, distanceFix2, distanceFix2_5, distanceFix3, distanceFix4, sizeHeightSmall, sizeHeightMiddle, sizeHeightBig, iconHeight, iconMenueHeight, height, height2, height3, height4, width, iconWidth, iconMenueWidth, posX, posY, firstPosX, firstPosY, sortByGroup, upDisplay)
	local maxSelectKey = 0;
	local helpTxt = "";
	function setSelectMarker(x, y, w, h)
		if not viGui.defaultHud.vehicleSettingsKeySelect.on then return;end;
		viGui:setBackgroundColor(self, viGui["designMarker"], viExtras.colors["green"]);		
		viGui:setOverlay(self, viGui["designMarker"], x, y, w, h);
		viGui["designMarker"]:render();		
	end;
	if not viGui.settingsOnViMenue.isLockDefaultHud then
		iconMenueHeight = viGui.buttonGfxHeight1*viGui.settingsOnViMenue.zoomOutIn*5;	
		iconMenueWidth = viGui.buttonGfxWidth1*viGui.settingsOnViMenue.zoomOutIn*6;			
		posX = viGui.settingsOnViMenue.posX;
		posY = viGui.settingsOnViMenue.posY-iconMenueHeight;
	end;	
	local menueWidth = iconMenueWidth;
	viGui:setOverlay(self, viGui["settings"], posX, posY, iconMenueWidth, iconMenueHeight);
	viGui:setOverlay(self, viGui["newPosMouse"], posX, posY, iconMenueWidth, iconMenueHeight);	
	if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == maxSelectKey then setSelectMarker(viGui["settings"].x, viGui["settings"].y, viGui["settings"].width, viGui["settings"].height);end;
	if viGui.settingsGuiMenue.on and viGui.defaultHud.timer["isTimer0"] > viGui.defaultHud.timer["timer0"]/2 and not viGui.settingsOnViMenue.isLockDefaultHud and not viGui.defaultHud.seeAnimals.dragDrop then
		viGui["newPosMouse"]:render();
		helpTxt = "press left mouse\nset new Position";
	else	
		viGui["settings"]:render();
		if g_currentMission.guiMenue.on and g_currentMission.guiMenue.modMenue ~= VehicleInspector.modMenue then
			helpText = "not Ready";
		elseif viGui.settingsGuiMenue.on and g_currentMission.guiMenue.modMenue == VehicleInspector.modMenue and not viGui.settingsOnViMenue.isLockDefaultHud then
			helpTxt = "press left mouse\nset new Position";
		elseif viGui.settingsGuiMenue.on then
			helpTxt = "VI Settings Menue is Open";
		else
			helpTxt = "VI Settings Menue Open";
		end;
	end;
	viGui.settingsOnViMenue.clickArea[#viGui.settingsOnViMenue.clickArea+1] = {posX, posX+iconMenueWidth, posY, posY+iconMenueHeight, "settings", tostring(helpTxt)};
	viGui:setOverlay(self, viGui["hidden"], posX+menueWidth, posY, iconMenueWidth, iconMenueHeight);
	if g_currentMission.vi.isHidden then
		if VehicleInspector.foundVehicleWarnings > 0 then
			viGui:setBackgroundColor(self, viGui["hidden"], viGui.defaultHud.warningColor2);		
		else
			viGui:setBackgroundColor(self, viGui["hidden"], viExtras.colors["gray"]);
		end;		
	else		
		viGui:setBackgroundColor(self, viGui["hidden"], viExtras.colors["grayInactive"]);		
	end;
	maxSelectKey = maxSelectKey-1;
	if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == maxSelectKey then setSelectMarker(viGui["hidden"].x-distanceFix1, viGui["hidden"].y-distanceFix1, viGui["hidden"].width+distanceFix2, viGui["hidden"].height+distanceFix2);end;
	viGui["hidden"]:render();
	viGui.settingsOnViMenue.clickArea[#viGui.settingsOnViMenue.clickArea+1] = {posX+menueWidth, posX+menueWidth+iconMenueWidth, posY, posY+iconMenueHeight, "hidden", "on/off Hidden"};
	menueWidth = menueWidth+iconMenueWidth;
	if VehicleInspector.foundVehicleWarnings > 0 then
		if not g_currentMission.vi.isHidden and viGui.defaultHud.timer["isTimer1"] < viGui.defaultHud.timer["timer1"]/2 and not viGui.defaultHud.seeGlobalWarningIcon and g_currentMission.vi.hiddenWarnings then
			setTextBold(true);
			setTextColor(unpack(viGui.defaultHud.warningColor2));
			renderText(posX+(menueWidth)-(iconMenueWidth/1.2), posY+(iconMenueHeight/3), sizeHeightBig, tostring(VehicleInspector.foundVehicleWarnings).. "x");
			setTextBold(false);
			--viGui.settingsOnViMenue.clickArea[#viGui.settingsOnViMenue.clickArea+1] = {posX+menueWidth, posX+menueWidth+iconMenueWidth, posY, posY+iconMenueHeight, "warnings", "see Only Warnings"};
		else
			if(viGui.defaultHud.seeGlobalWarningIcon and not g_currentMission.vi.isHidden) or (viGui.defaultHud.seeGlobalWarningIcon and g_currentMission.vi.isHidden and g_currentMission.vi.hiddenWarnings) and not viGui.defaultHud.seeGlobalWarningVehicleAutoOnHidden then
				viGui:setOverlay(self, viGui["warning"], posX+menueWidth, posY, iconMenueWidth, iconMenueHeight);			
				viGui.settingsOnViMenue.clickArea[#viGui.settingsOnViMenue.clickArea+1] = {posX+menueWidth, posX+menueWidth+iconMenueWidth, posY, posY+iconMenueHeight, "warnings", "see Only Warnings"};
				menueWidth = menueWidth+iconMenueWidth;
				maxSelectKey = maxSelectKey-1;				
				if viGui.defaultHud.timer["isTimer1"] > viGui.defaultHud.timer["timer1"]/2 then
					if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == maxSelectKey then setSelectMarker(viGui["warning"].x-distanceFix1, viGui["warning"].y-distanceFix1, viGui["warning"].width+distanceFix1, viGui["warning"].height+distanceFix1);end;
					viGui["warning"]:render();
				else
					if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == maxSelectKey then setSelectMarker(viGui["warning"].x, viGui["warning"].y, viGui["warning"].width, viGui["warning"].height);end;
					setTextBold(true);
					setTextColor(unpack(viGui.defaultHud.warningColor2));
					--renderText(posX+(menueWidth)-(iconMenueWidth/1.2), posY+(iconMenueHeight/3), sizeHeightBig, "20x");
					renderText(posX+(menueWidth)-(iconMenueWidth/1.2), posY+(iconMenueHeight/3), sizeHeightBig, tostring(VehicleInspector.foundVehicleWarnings).. "x");
					setTextColor(unpack(viGui.defaultHud.textColor));
					setTextBold(false);
				end;
			end;
			--menueWidth = menueWidth+distanceFix2+getTextWidth(sizeHeightBig, tostring(VehicleInspector.foundVehicleWarnings).. "x");			
		--elseif viGui.defaultHud.seeGlobalWarningVehicleAutoOnHidden then
		--	viGui:setOverlay(self, viGui["warning"], posX+menueWidth, posY, false, false);
		--	menueWidth = menueWidth+iconMenueWidth;
		--	viGui["warning"]:render();
		end;
	end;	
	if viGui.settingsOnViMenue.isTask then
		viGui:setOverlay(self, viGui["leftArrow"], posX+(menueWidth), posY, iconMenueWidth, iconMenueHeight);
		viGui:setOverlay(self, viGui["rightArrow"], posX+(menueWidth), posY, iconMenueWidth, iconMenueHeight);
		helpTxt = "";
		maxSelectKey = maxSelectKey-1;
		viGui.settingsOnViMenue.taskSelectKey = maxSelectKey;
		if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == maxSelectKey then setSelectMarker(viGui["leftArrow"].x, viGui["leftArrow"].y, viGui["leftArrow"].width, viGui["leftArrow"].height);end;
		if viGui.settingsOnViMenue.isTaskOpen then		
			viGui["leftArrow"]:render();
			helpTxt = "close Taskbar";
		else
			viGui["rightArrow"]:render();
			helpTxt = "open Taskbar";
			maxSelectKey = maxSelectKey+#viGui.settingsOnViMenue.taskClickArea;
		end;
		viGui.settingsOnViMenue.clickArea[#viGui.settingsOnViMenue.clickArea+1] = {posX+menueWidth, posX+menueWidth+iconMenueWidth, posY, posY+iconMenueHeight, "onTask", tostring(helpTxt)};
		menueWidth = menueWidth+iconMenueWidth;		
	end;
	viGui.settingsOnViMenue.maxSelectKey = maxSelectKey;
	viGui.settingsOnViMenue.dragDropGround = {width=menueWidth, height=iconMenueHeight};
end;

--ItemsDesign,storeItems,seeTrailerLine 2
function viDraw:loadDesign1(self, distanceFix1, distanceFix2, distanceFix2_5, distanceFix3, distanceFix4, sizeHeightSmall, sizeHeightMiddle, sizeHeightBig, iconHeight, iconMenueHeight, height, height2, height3, height4, width, iconWidth, iconMenueWidth, posX, posY, firstPosX, firstPosY, sortByGroup, upDisplay)	
	viGui:resetOverlayDesignGroundAndLine(self);
	local designGround, designLine, designGroupLine, designMarker = getDesignGroundAndLine(self);
	--local distanceFix1 = 0.001;
	--local distanceFix2 = 0.002;
	--local distanceFix2_5 = 0.0025;
	--local distanceFix3 = 0.003;	
	--local distanceFix4 = 0.004;
	--local sizeHeightSmall = getTextHeight(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*2.7, "----Test----")
	--local sizeHeightMiddle = getTextHeight(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*2.9, "----Test----")
	--local sizeHeightBig = getTextHeight(viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*3, "----Test----")	
	--local iconHeight = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*4;
	--local iconMenueHeight = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*5;
	--local height = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*8;
	--local height2 = height/2;
	--local height3 = height/3;
	--local height4 = height/4;
	--local width = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*(9+viGui.defaultHud.distanceAttachedStretch);
	--local iconWidth = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*5;
	--local iconMenueWidth = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*6;
	--local upDisplay = (viGui.defaultHud.pos == 4 or viGui.defaultHud.pos == 5 or viGui.defaultHud.pos == 6);	
	--local posX = viGui.defaultHud.posX;
	--local posY = viGui.defaultHud.posY-height;
	--if upDisplay then posY = viGui.defaultHud.posY;end;
	--local firstPosX = posX;
	--local firstPosY = posY;	
	--local sortByGroup = VehicleInspector.foundGroupManager and viGui.defaultHud.sortBy.isGroup;	
	local oldGroup = -1;
	local firstLine = false;	
	function nextPosY(posNew)
		if posNew ~= nil then
			if not upDisplay then			
				--firstPosXY = firstPosXY-(sizeHeight+posNew);		
				posY = posY-(posNew);
			else			
				--firstPosXY = firstPosXY+(sizeHeight+posNew);		
				posY = posY+(posNew);			
			end;
		end;
	end;
	function nextDesignLine(upPosY, setLine, group)		
		if setLine then			
			viGui:setOverlay(self, designLine, posX, posY-distanceFix1, iconWidth+width+(width*VehicleInspector.foundMaxAttached), distanceFix1); --posB old 0.035
			designLine:render();
			if sortByGroup and group ~= oldGroup then					
				oldGroup = group;
				if not upDisplay then
					nextDesignLine(true, false, oldGroup);
					firstLine = true;
				else				
					viGui:setOverlay(self, designGroupLine, posX, posY-distanceFix1, iconWidth+width+(width*VehicleInspector.foundMaxAttached), distanceFix1); --posB old 0.035
					designGroupLine:render();
					if viGui.defaultHud.seeGroup[12] then
						setTextColor(unpack(viExtras.colors["ls15"]));
						renderText(posX+(designGroupLine.width)-distanceFix1, posY-distanceFix1, sizeHeightSmall, tostring(group));
						setTextColor(unpack(viGui.defaultHud.textColor));
					end;
				end;			
			end;
		end;
		if upPosY then			
			viGui:setOverlay(self, designLine, posX, posY+height-designLine.height-distanceFix1, iconWidth+width+(width*VehicleInspector.foundMaxAttached), distanceFix1); --posB old 0.035
			designLine:render();
			if sortByGroup then				
				viGui:setOverlay(self, designGroupLine, posX, posY+height-designLine.height-distanceFix1, iconWidth+width+(width*VehicleInspector.foundMaxAttached), distanceFix2); --posB old 0.035
				designGroupLine:render();
				if oldGroup	~= -1 and viGui.defaultHud.seeGroup[12] then			
					setTextColor(unpack(viExtras.colors["ls15"]));
					if not upDisplay then
						renderText(posX+(designGroupLine.width), posY+height-designLine.height-distanceFix1-(sizeHeightSmall/2), sizeHeightSmall, tostring(group));
					else
						renderText(posX+(designGroupLine.width)-distanceFix1, posY+height-designLine.height-distanceFix1, sizeHeightSmall, tostring(group));
					end;
					setTextColor(unpack(viGui.defaultHud.textColor));
				end;
				oldGroup = group;
			end;
		end;
	end;
	function nextDesignGroundAndMarker(x, y, w, h, vehicleSettingsKeySelect)
		viGui:setOverlay(self, designGround, x, y, iconWidth+width+(width*VehicleInspector.foundMaxAttached), h);			
		if viGui.defaultHud.designGroundType ~= 0 then designGround:render();end;
		if viGui.defaultHud.seeExtraIcon.isDraw then
			viGui:setOverlay(self, designLine, x+designGround.width-(iconWidth*2), y-distanceFix1, distanceFix1, designGround.height);
			designLine:render();
		end;
		if vehicleSettingsKeySelect then			
			local markerPosX = x;
			if viGui.defaultHud.vehicleSettingsKeySelect.pos == 0 then
				viGui:setOverlay(self, designMarker, x, y-distanceFix1, distanceFix1, designGround.height);				
			elseif viGui.defaultHud.vehicleSettingsKeySelect.pos == 1 then
				viGui:setOverlay(self, designMarker, x+(iconWidth*1), y-distanceFix1, distanceFix1, designGround.height);
				markerPosX = x+(iconWidth*1);
			elseif viGui.defaultHud.vehicleSettingsKeySelect.pos == 2 then
				viGui:setOverlay(self, designMarker, x+designGround.width-(iconWidth*2), y-distanceFix1, distanceFix1, designGround.height);			
				markerPosX = x+designGround.width-(iconWidth*2);
			elseif viGui.defaultHud.vehicleSettingsKeySelect.pos == 3 then
				viGui:setOverlay(self, designMarker, x+designGround.width, y-distanceFix1, distanceFix1, designGround.height);
				markerPosX = x+designGround.width;
			end;			
			if viGui.defaultHud.vehicleSettingsKeySelect.markerType == 1 then
				designMarker:render();
				viGui:setOverlay(self, designMarker, markerPosX, y+designGround.height-distanceFix2, distanceFix3, distanceFix2);
				designMarker:render();
				viGui:setOverlay(self, designMarker, markerPosX, y-distanceFix1, distanceFix3, distanceFix2);
				designMarker:render();
			elseif viGui.defaultHud.vehicleSettingsKeySelect.markerType == 2 then
				designMarker:render();
				viGui:setOverlay(self, designMarker, markerPosX-distanceFix3, y+designGround.height-distanceFix2, distanceFix3, distanceFix2);
				designMarker:render();
				viGui:setOverlay(self, designMarker, markerPosX-distanceFix3, y-distanceFix1, distanceFix3, distanceFix2);
				designMarker:render();
			elseif viGui.defaultHud.vehicleSettingsKeySelect.markerType == 3 then
				--viGui:setBackgroundColor(self, designMarker, viExtras.colors["ls15GroundInactive"]);
				local extraDraw = 0;
				if viGui.defaultHud.seeExtraIcon.isDraw then extraDraw = 1;end;
				if viGui.defaultHud.vehicleSettingsKeySelect.pos == 0 then
					viGui:setOverlay(self, designMarker, x, y, iconWidth, h);
				elseif viGui.defaultHud.vehicleSettingsKeySelect.pos == 1 or viGui.defaultHud.vehicleSettingsKeySelect.pos == 2 then
					viGui:setOverlay(self, designMarker, x+iconWidth, y, width+(width*(VehicleInspector.foundMaxAttached-extraDraw)), h);
				elseif viGui.defaultHud.vehicleSettingsKeySelect.pos == 3 then
					viGui:setOverlay(self, designMarker, x+iconWidth+(width*VehicleInspector.foundMaxAttached), y, width, h);
				end;
				designMarker:render();				
			end;
		end;
	end;
	function stretchDesignGround(x, y, stretchWidth, stretchHeight)
		viGui:setOverlay(self, designGround, x, y, stretchWidth, stretchHeight);
		--designGround:render();
	end;
	local oldCarWash = {prozent=0};
	local oldVehicleCost = {prozent=0, found=0};
	local masterVehicle = nil;
	function setExtraIcon(vehicle, isBlockedAndName, color)
		local nextExtraIcon = 0;
		local nextIcon = true;
		local doubleIconPos1 = false;
		if nextIcon and viGui.defaultHud.seeExtraIcon.light and viGui.defaultHud.seeExtraIcon.isDraw then
			viGui:setOverlay(self, viGui["light"], posX+designGround.width-(iconWidth*2)+distanceFix2, posY+height2, false, false);
			if vehicle.currentLightState > 0 or vehicle.lightsTypesMask > 0 then
				viGui["light"]:render();
				--nextExtraIcon = nextExtraIcon+iconWidth;			
			end;
		end;
		local doubleIconPos2 = false;
		if viGui.defaultHud.seeExtraIcon.isDraw and viGui.defaultHud.seeExtraIcon.dirtAmount or masterVehicle.viValue.globalWarning.foundDirtAmount > 0 then
			local prozent = vehicle.viValue.dirtAmount.dirtAmountProzent;
			local extraIconPosX = posX+designGround.width+distanceFix2-(iconWidth);
			viGui:setOverlay(self, viGui["carWash"], extraIconPosX, posY+height2, false, false);
			if prozent ~= nil or oldCarWash.prozent > 0 then
				if prozent == nil then prozent = oldCarWash.prozent;end;
				if (oldCarWash.prozent > 0 and tonumber(prozent) >= oldCarWash.prozent) or oldCarWash.prozent == 0 then oldCarWash.prozent = tonumber(prozent);end;				
				local alternateTxt = "";
				if masterVehicle.viValue.globalWarning.foundDirtAmount > 1 then alternateTxt = "\nFound ".. tostring(masterVehicle.viValue.globalWarning.foundDirtAmount).. "x see highest Dirt Amount";end;
				if tonumber(prozent) >= viGui.defaultHud.seeExtraIcon.dirtAmountProzent or masterVehicle.viValue.globalWarning.foundDirtAmount > 0 then					
					if tonumber(prozent)>= 99 then
						viGui:setBackgroundColor(self, viGui["carWash"], viGui.defaultHud.warningColor4);
					elseif tonumber(prozent) >= 100-(viGui.defaultHud.seeExtraIcon.dirtAmountProzent/2) then	
						viGui:setBackgroundColor(self, viGui["carWash"], viGui.defaultHud.warningColor3);
					else
						viGui:setBackgroundColor(self, viGui["carWash"], viGui.defaultHud.warningColor2);
					end;					
					if (viGui.defaultHud.seeExtraIcon.vehicleCost and viGui.defaultHud.timer["isTimer2"] < viGui.defaultHud.timer["timer2"]/2 and not doubleIconPos2) or not viGui.defaultHud.seeExtraIcon.vehicleCost or masterVehicle.viValue.globalWarning.foundVehicleCost <= 0 then
						viGui["carWash"]:render();
						viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {extraIconPosX, extraIconPosX+iconWidth, posY+height2, posY+(height2*2), vehicle=vehicle, what="carWash", getTxt="Dirt: ".. tostring(string.format("%1.1f", "".. tonumber(prozent))).."%".. tostring(alternateTxt)}; 
						doubleIconPos2 = true;
					end;
				end;			
			end;
		end;
		if viGui.defaultHud.seeExtraIcon.isDraw and viGui.defaultHud.seeExtraIcon.vehicleCost then
			local extraIconPosX = posX+designGround.width+distanceFix2-(iconWidth);
			viGui:setOverlay(self, viGui["money"], extraIconPosX, posY+height2, false, false);			
			viGui:setBackgroundColor(self, viGui["money"], viGui.defaultHud.warningColor3);				
			local sellPrice, price, multiplier = viSetGet:getSellPriceAndMulitplier(self, vehicle);
			local upKeep, defaultUpKeep = viSetGet:getDailyUpKeep(self, vehicle);
			--local msPrice = Utils.getNoNil(vehicle.pricePerMS,0)*60*60*60;
			if (sellPrice ~= nil and price ~= nil) or oldVehicleCost.prozent > 0 then
				if sellPrice == nil or price == nil then sellPrice = oldVehicleCost.prozent;price = oldVehicleCost.prozent;end;
				local isPriceProzent = 0;
				local isSellProzent = 0;
				if sellPrice ~= nil and price ~= nil then
					isPriceProzent = price/100;
					isSellProzent = 100-(sellPrice/isPriceProzent);
				else
					isSellProzent = 100;
					if oldVehicleCost.prozent > 0 then isSellProzent = oldVehicleCost.prozent;end;
				end;				
				local alternateTxt = "";
				if oldVehicleCost.found > 0 then alternateTxt = "\nFound ".. tostring(oldVehicleCost.found).. "x see highest Vehicle Upkeep";end;
				if (oldVehicleCost.prozent > 0 and tonumber(isSellProzent) >= oldVehicleCost.prozent) or oldVehicleCost.prozent == 0 then oldVehicleCost.prozent = tonumber(isSellProzent);end;
				oldVehicleCost.found = oldVehicleCost.found+1;
				if tonumber(isSellProzent) >= viGui.defaultHud.seeExtraIcon.vehicleCostProzent then
					if tonumber(isSellProzent) >= 95 then
						viGui:setBackgroundColor(self, viGui["money"], viGui.defaultHud.warningColor4);
					elseif tonumber(isSellProzent) >= 100-(viGui.defaultHud.seeExtraIcon.vehicleCostProzent/2) then
						viGui:setBackgroundColor(self, viGui["money"], viGui.defaultHud.warningColor3);
					else
						viGui:setBackgroundColor(self, viGui["money"], viGui.defaultHud.warningColor2);
					end;
					if (viGui.defaultHud.seeExtraIcon.dirtAmount and viGui.defaultHud.timer["isTimer2"] > viGui.defaultHud.timer["timer2"]/2 and not doubleIconPos2) or not viGui.defaultHud.seeExtraIcon.dirtAmount or not doubleIconPos2 then
						viGui["money"]:render();
						viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {extraIconPosX, extraIconPosX+iconWidth, posY+height2, posY+(height2*2), vehicle=vehicle, what="money", getTxt="DailyUpKeep: ".. tostring(g_i18n:formatMoney(upKeep)).. "(".. tostring(g_i18n:formatMoney(defaultUpKeep)).. ")\nMoneySell: ".. tostring(g_i18n:formatMoney(sellPrice)).. "\nMoneyBuy: ".. tostring(g_i18n:formatMoney(price)).. tostring(alternateTxt)}; 
					end;
				end;
			end;			
		end;
		local doubleIconPos3 = false;
		if viGui.defaultHud.seeExtraIcon.isDraw and viGui.defaultHud.seeExtraIcon.rentCar and (vehicle.propertyState == 2 or masterVehicle.viValue.globalWarning.foundRentCar > 0) then
			local extraIconPosX = posX+designGround.width+distanceFix2-(iconWidth*2);
			viGui:setOverlay(self, viGui["rentcar"], extraIconPosX, posY, false, false);			
			viGui["rentcar"]:render();
			--nextExtraIcon = nextExtraIcon+iconWidth;
			local cost = g_i18n:formatMoney(masterVehicle.viValue.globalWarning.rentCarCost); --g_i18n:formatNumber(vehicle.viValue.globalWarning.rentCarCost); --6%
			local txt = "RentCar: ".. tostring(cost);
			if masterVehicle.viValue.globalWarning.foundRentCar > 1 then
				txt = "RentCar(".. tostring(masterVehicle.viValue.globalWarning.foundRentCar).. "x): ".. tostring(cost);
			end;
			viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {extraIconPosX, extraIconPosX+iconWidth, posY, posY+(height2), vehicle=vehicle, what="rentCar", getTxt=tostring(txt)}; 
		end;
		local doubleIconPos4 = false;
		if viGui.defaultHud.seeExtraIcon.isDraw and nextIcon and viGui.defaultHud.seeExtraIcon.fuelLevel then								
			local prozent = vehicle.viValue.fuel.fuelLevelProzent; --viSetGet:getFuelLevel(self, vehicle, true);
			local extraIconPosX = posX+designGround.width+distanceFix2-(iconWidth);
			viGui:setOverlay(self, viGui["fuel"], extraIconPosX, posY, false, false);			
			local setIcon = false;
			if prozent ~= nil and tonumber(prozent) <= viGui.defaultHud.seeExtraIcon.fuelLevelProzent then
				if tonumber(prozent) <= 0 then
					viGui:setBackgroundColor(self, viGui["fuel"], viGui.defaultHud.warningColor4);
				elseif tonumber(prozent) <= viGui.defaultHud.seeExtraIcon.fuelLevelProzent/2 then
					viGui:setBackgroundColor(self, viGui["fuel"], viGui.defaultHud.warningColor3);
				else
					viGui:setBackgroundColor(self, viGui["fuel"], viGui.defaultHud.warningColor2);
				end;
				if viGui.defaultHud.seeExtraIcon.fuelLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeExtraIcon.fuelLevelTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeExtraIcon.fuelLevelTimer]/2 then
					viGui["fuel"]:render();
					setIcon = true;
					nextExtraIcon = nextExtraIcon+iconWidth;
				end;
				viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {extraIconPosX, extraIconPosX+iconWidth, posY, posY+(height2*1), vehicle=vehicle, what="fuel", getTxt="Fuel: ".. tostring(string.format("%1.1f", "".. tonumber(prozent))).."%"};
			end;
			if prozent ~= nil and not setIcon and string.len(isBlockedAndName) > 0 and isBlockedAndName == "Refuel" then
				setTextColor(unpack(color));
				renderText(posX+designGround.width+distanceFix2+nextExtraIcon, posY+height2, sizeHeightMiddle, tostring(isBlockedAndName).. " -> ".. tostring(prozent).. "%");
				setTextColor(unpack(viGui.defaultHud.textColor));
				nextIcon = false;
			elseif prozent ~= nil and setIcon and masterVehicle.viValue.globalWarning.isWarning and string.len(masterVehicle.viValue.globalWarning.warningTxt) > 0 and (masterVehicle.viValue.globalWarning.warningTxt == "! Fuel Empty !") then
				setTextColor(unpack(viGui.defaultHud.warningColor3));
				renderText(posX+designGround.width+distanceFix2+nextExtraIcon, posY+height2, sizeHeightMiddle, tostring(masterVehicle.viValue.globalWarning.warningTxt));
				setTextColor(unpack(viGui.defaultHud.textColor));
				nextIcon = false;	
			end;
		end;
		if nextIcon and viGui.defaultHud.seeExtraIcon.fillLevel then
			viGui:setOverlay(self, viGui["attention"], posX+designGround.width+distanceFix2+nextExtraIcon, posY+height2, false, false);			
			local prozent = vehicle.viValue.fill.fillLevelProzent;
			local seedsOrSprayerProzent = 100-viGui.defaultHud.seeExtraIcon.fillLevelProzent;			
			if prozent ~= nil then			
				if (vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) <= tonumber(seedsOrSprayerProzent)) or (not vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) >= viGui.defaultHud.seeExtraIcon.fillLevelProzent) then
					if (vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) <= 0) or (not vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) >= 100) then
						viGui:setBackgroundColor(self, viGui["attention"], viGui.defaultHud.warningColor4);
					elseif (vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) <= tonumber(seedsOrSprayerProzent)/2) or (not vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) >= ((100-viGui.defaultHud.seeExtraIcon.fillLevelProzent)/2)+viGui.defaultHud.seeExtraIcon.fillLevelProzent) then	
						viGui:setBackgroundColor(self, viGui["attention"], viGui.defaultHud.warningColor3);
					else
						viGui:setBackgroundColor(self, viGui["attention"], viGui.defaultHud.warningColor2);
					end;
					local setIcon = false;
					if viGui.defaultHud.seeExtraIcon.fillLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeExtraIcon.fillLevelTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeExtraIcon.fillLevelTimer]/2 then
						viGui["attention"]:render();
						setIcon = true;
						nextExtraIcon = nextExtraIcon+iconWidth;
					end;
					if setIcon and masterVehicle.viValue.globalWarning.isWarning and string.len(masterVehicle.viValue.globalWarning.warningTxt) > 0 and (masterVehicle.viValue.globalWarning.warningTxt == "! Full !" or masterVehicle.viValue.globalWarning.warningTxt == "! Empty !") then
						if (vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent) <= 0) or (not vehicle.viValue.fill.isSeedsOrSprayer and tonumber(prozent)>= 100) then
							setTextColor(unpack(viGui.defaultHud.warningColor3));
							renderText(posX+designGround.width+distanceFix2+nextExtraIcon, posY+height2, sizeHeightMiddle, tostring(vehicle.viValue.globalWarning.warningTxt));
							setTextColor(unpack(viGui.defaultHud.textColor));
							nextIcon = false;
						end;
					end;
				end;				
			end;									
		end;		
	end;	
	if viGui.settingsOnViMenue.isLockDefaultHud then nextPosY(height);end;
	if (g_currentMission.vi.isHidden and not viGui.defaultHud.seeGlobalWarningVehicle and not viGui.defaultHud.seeGlobalWarningVehicleAutoOnHidden) then viGui.defaultHud.vehicleSettingsKeySelect.node=nil;return;end;
	local vehicleLastNode = nil;
	local vehicleFirstNode = nil;
	function setGetKeySelect(markerLine, node, incorrect)
		if not viGui.defaultHud.vehicleSettingsKeySelect.on or viGui.defaultHud.vehicleSettingsKeySelect.keyPos <= 0 then viGui.defaultHud.vehicleSettingsKeySelect.node = nil;return false;end;
		if incorrect then viGui.defaultHud.vehicleSettingsKeySelect.keyPos = markerLine;viGui.defaultHud.vehicleSettingsKeySelect.node = node;return;end;		
		if viGui.defaultHud.vehicleSettingsKeySelect.keyPos == markerLine then
			viGui.defaultHud.vehicleSettingsKeySelect.node = node;
			return true;
		end;
		return false;
	end;
	if viVehicles ~= nil and #viVehicles > 0 then		
		--stretchDesignGround(posX, posY, iconWidth, height);
		--designGround:render();
		for a=1, #viVehicles do
		--for key,value in pairs(viVehicles) do
			if viVehicles[a].rootNode ~= nil and g_currentMission.nodeToVehicle[viVehicles[a].rootNode] ~= nil then				
				oldCarWash.prozent = 0;
				oldVehicleCost.prozent = 0;
				oldVehicleCost.found = 0;
				local vehicle = g_currentMission.nodeToVehicle[viVehicles[a].rootNode];
				masterVehicle = vehicle;
				setTextColor(unpack(viGui.defaultHud.textColor));				
				local isControlledClientPlayer = viDraw:isVehicleClientPlayer(self, vehicle);				 
				--if vehicle.isControlled or vehicle.isHired then
				if (viGui.defaultHud.seeGlobalWarningVehicle and vehicle.viValue.globalWarning.isWarning) or (viGui.defaultHud.seeGlobalWarningVehicle and vehicle.viValue.globalWarning.foundDirtAmount > 0) or not g_currentMission.vi.isHidden or (g_currentMission.vi.isHidden and viGui.defaultHud.seeGlobalWarningVehicleAutoOnHidden and vehicle.viValue.globalWarning.isWarning) or (viSetGet:seeControlled(self, vehicle) and isControlledClientPlayer) then
					if vehicleFirstNode == nil then vehicleFirstNode = viVehicles[a].rootNode;end;
					vehicleLastNode = viVehicles[a].rootNode;
					viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter = viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter+1;
					setTextBold(false);
					nextDesignGroundAndMarker(posX, posY, 0, height, setGetKeySelect(viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter, viVehicles[a].rootNode, false));
					--stretchDesignGround(posX, posY, iconWidth, designGround.height+height)
					local newGroup = oldGroup;
					if sortByGroup and vehicle["modVeGS"] ~= nil and vehicle["modVeGS"]["group"] ~= nil then
						newGroup = vehicle["modVeGS"]["group"];
					end;					
					nextDesignLine(false, true, newGroup);					
					viGui:setOverlay(self, viGui["field"], posX, posY+height2, false, false);
					viGui["field"]:render();
					setTextAlignment(1);					
					renderText(posX+(viGui["field"].width/2), posY+height2+(viGui["field"].height/3), sizeHeightMiddle, tostring(getIsOnField(self, vehicle)));
					setTextAlignment(0)
					setTextBold(true);
					if vehicle.isMotorStarted then
						local isSpeed = getSpeed(self, vehicle);
						if tonumber(isSpeed) == 0 then
							viGui:setOverlay(self, viGui["park"], posX, posY, false, false);
							viGui:setBackgroundColor(self, viGui["park"], viGui.defaultHud.warningColor2);
							viGui["park"]:render();
						else
							viGui:setOverlay(self, viGui["speed"], posX, posY+distanceFix2_5, false, false);
							viGui["speed"]:render();
							renderText(posX, posY+distanceFix1, sizeHeightBig, tostring(isSpeed));
						end;
					else
						viGui:setOverlay(self, viGui["park"], posX, posY, false, false);
						viGui:setBackgroundColor(self, viGui["park"], viGui.defaultHud.warningColor4);
						viGui["park"]:render();
					end;					
					viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX, posX+iconWidth, posY, posY+height, vehicle=vehicle, what="joinVehicle"};
					local foundAttached = 1;
					function setStoreItem(vehicleStore, iconWidthNew, isAttached, defaultWidthHeight, isMounted)
						--local storeItemWidth = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*10;
						--local storeItemHeight = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*9;
						--if not defaultWidthHeight then storeItemWidth = viGui.buttonGfxWidth1*viGui.defaultHud.zoomOutIn*8;storeItemHeight = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*7;end;
						local setStoreItems = vehicleStore.viStoreItem ~= nil and viStoreItems[vehicleStore.viStoreItem] ~= nil;
						--if vehicleStore.viStoreItem ~= nil and viStoreItems[vehicleStore.viStoreItem] ~= nil then
							--if designGround.width < iconWidth+(width*foundAttached) then stretchDesignGround(false, false, iconWidth+(width*foundAttached), false);end;
							viGui:setOverlay(self, viStoreItems[vehicleStore.viStoreItem], posX+iconWidthNew, posY, false, false);
							--viGui:setBackgroundColor(self, viStoreItems[vehicleStore.viStoreItem], viExtras.colors["hover"]);
							if setStoreItems and ((not isAttached and viGui.defaultHud.storeItemsVehicle) or (isAttached and viGui.defaultHud.storeItemsAttached)) then 
								viStoreItems[vehicleStore.viStoreItem]:render();
							elseif ((not isAttached and not viGui.defaultHud.storeItemsVehicle and viGui.defaultHud.storeItemsVehicleName) or (isAttached and not viGui.defaultHud.storeItemsAttached and viGui.defaultHud.storeItemsAttachedName)) then
								setTextColor(unpack(viGui.defaultHud.warningColor3));
								renderText(posX+iconWidthNew, posY+height3, sizeHeightSmall, tostring(getVehicleLenghtName(vehicleStore, 5)));
							end;							
							viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+iconWidthNew, posX+iconWidthNew+width, posY, posY+viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn*9, vehicle=vehicleStore, what="vehicleName", getTxt=tostring(getVehicleLenghtName(vehicleStore, 40))};
							if isControlledClientPlayer and getSelectable(self, vehicleStore) then
								viGui:setOverlay(self, viGui["select"], posX+iconWidth+(width*foundAttached), posY-distanceFix1, width, false);
								viGui["select"]:render();
							end;
							local txtString = "";
							setTextColor(unpack(viGui.defaultHud.textColor));
							local prozent = nil; 
							local fillLevel = nil;
							local fillType = nil;
							local capacity = nil;
							if viGui.helpText.vehicleInfo then
								prozent = viSetGet:getFillLevel(self, vehicleStore, true);
								if prozent ~= nil then
									if string.find(prozent, "nan") or string.find(prozent, "inf") then prozent = 0;end;
									txtString = prozent;
									if string.len(txtString) > 0 or tonumber(txtString) == 0 then txtString = txtString.. "%";end;
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nProzent: ".. tostring(txtString);
								end;
								fillLevel = viSetGet:getFillLevel(self, vehicleStore, false);
								capacity = viSetGet:getFillCapacity(self, vehicleStore, false);
								if fillLevel ~= nil then
									if string.find(fillLevel, "nan") or string.find(fillLevel, "inf") then fillLevel = 0;end;
									txtString = fillLevel;
									if string.len(txtString) > 0 or tonumber(txtString) == 0 then txtString = g_i18n:formatNumber(tonumber(fillLevel));end;
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nFillLevel: ".. tostring(txtString);
								end;
								if capacity ~= nil then
									txtString = capacity;
									if string.len(txtString) > 0 and tonumber(txtString) ~= 0 then txtString = g_i18n:formatNumber(tonumber(capacity));end;
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nCapacity: ".. tostring(txtString);
								end;
								fillType = getFillType(self, vehicleStore, true, 50, isMounted, true);
								if fillType ~= nil and fillType ~= 0 then									
									txtString = fillType;
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nFruitName: ".. tostring(txtString);
								end;
								if not viGui.defaultHud.seeExtraIcon.fuelLevel or not viGui.defaultHud.seeExtraIcon.isDraw then
									local prozentFuel = vehicle.viValue.fuel.fuelLevelProzent;
									if prozentFuel ~= nil and not isAttached then										
										viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nFuel: ".. tostring(string.format("%1.1f", "".. tonumber(prozentFuel))).."%";
									end;
								end;
								if (not viGui.defaultHud.seeExtraIcon.dirtAmount or not viGui.defaultHud.seeExtraIcon.isDraw) then
									local prozentDirt = Utils.getNoNil(vehicleStore.viValue.dirtAmount.dirtAmountProzent, nil);
									if prozentDirt ~= nil then										
										viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nDirt: ".. tostring(string.format("%1.1f", "".. tonumber(prozentDirt))).."%";
									end;
								end;
								if vehicleStore.propertyState == 2 and (not viGui.defaultHud.seeExtraIcon.rentCar or not viGui.defaultHud.seeExtraIcon.isDraw) then 
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nRentCar: ".. tostring(g_i18n:formatNumber(vehicleStore.viValue.globalWarning.rentCarCost)).. "€";
								end;								
								if Utils.getNoNil(vehicleStore.age, false) then
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt = viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea].getTxt.. "\nAge: ".. tostring(g_i18n:formatNumber(vehicleStore.age));
								end;
							end;
							local pos1 = false;
							local pos2 = false;
							local pos1Max = 0;
							local pos2Max = 0;							
							if viGui.defaultHud.seeText.prozent and viGui.defaultHud.seeText.prozentPos == 1 then pos1Max = pos1Max+1;end;
							if viGui.defaultHud.seeText.prozent and viGui.defaultHud.seeText.prozentPos == 2 then pos2Max = pos2Max+1;end;
							if viGui.defaultHud.seeText.fillLevel and viGui.defaultHud.seeText.fillLevelPos == 1 then pos1Max = pos1Max+1;end;
							if viGui.defaultHud.seeText.fillLevel and viGui.defaultHud.seeText.fillLevelPos == 2 then pos2Max = pos2Max+1;end;
							if viGui.defaultHud.seeText.fruitName and viGui.defaultHud.seeText.fruitNamePos == 1 then pos1Max = pos1Max+1;end;
							if viGui.defaultHud.seeText.fruitName and viGui.defaultHud.seeText.fruitNamePos == 2 then pos2Max = pos2Max+1;end;							
							local switchTimer1 = viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/3;
							local switchTimer2 = switchTimer1*2;
							local switchTimer3 = viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer];
							if viGui.defaultHud.seeText.prozent then --viGui.defaultHud.seeProzent --old								
								if not viGui.helpText.vehicleInfo then prozent = viSetGet:getFillLevel(self, vehicleStore, true);end;								
								if prozent ~= nil then
									if string.find(prozent, "nan") or string.find(prozent, "inf") or tonumber(prozent) == 0 then prozent = "";end;
									txtString = prozent;
									if string.len(txtString) > 0 and tonumber(txtString) ~= 0 then txtString = txtString.. "%";end;
									if viGui.defaultHud.seeText.prozentPos == 1 then
										if pos1Max > 1 then
											if viGui.defaultHud.seeText.switch then
												if viGui.defaultHud.seeText.switchTimer == -1 or 
												(pos1Max == 2 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos1Max == 3 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] <= switchTimer1) then												
													pos1 = true;
													renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, sizeHeightSmall, tostring(txtString));
												end;
											elseif viGui.defaultHud.seeText.prozentTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.prozentTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.prozentTimer]/2 then
												pos1 = true;
												renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, sizeHeightSmall, tostring(txtString));
											end;
										elseif viGui.defaultHud.seeText.prozentTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.prozentTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.prozentTimer]/2 then
											pos1 = true;
											renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, sizeHeightSmall, tostring(txtString));
										end;
									elseif viGui.defaultHud.seeText.prozentPos == 2 then
										if pos2Max > 1 then
											if viGui.defaultHud.seeText.switch then
												if viGui.defaultHud.seeText.switchTimer == -1 or 
												(pos2Max == 2 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos2Max == 3 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] <= switchTimer1) then
													pos2 = true;
													renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
												end;
											elseif viGui.defaultHud.seeText.prozentTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.prozentTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.prozentTimer]/2 then
												pos2 = true;
												renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
											end;
										elseif viGui.defaultHud.seeText.prozentTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.prozentTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.prozentTimer]/2 then
											pos2 = true;
											renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
										end;							
									end;
								end;
							end;
							if viGui.defaultHud.seeText.fillLevel then
								if not viGui.helpText.vehicleInfo then fillLevel = viSetGet:getFillLevel(self, vehicleStore, false);end;							
								if fillLevel ~= nil then
									if string.find(fillLevel, "nan") or string.find(fillLevel, "inf") or tonumber(fillLevel) == 0 then fillLevel = "";end;
									txtString = fillLevel;
									if string.len(txtString) > 0 and tonumber(txtString) ~= 0 then txtString = g_i18n:formatNumber(tonumber(fillLevel));end; --string.format("%1.0f", "".. tonumber(fillLevel)).. "L";end;
									local optimalSize = Utils.getNoNil(getOptimalSize(width, txtString, sizeHeightSmall), sizeHeightSmall);
									
									if viGui.defaultHud.seeText.fillLevelPos == 1 and not pos1 then
										if pos1Max > 1 then
											if viGui.defaultHud.seeText.switch then
												if viGui.defaultHud.seeText.switchTimer == -1 or 
												(pos1Max == 2 and viGui.defaultHud.seeText.prozent and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] < viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or
												(pos1Max == 2 and not viGui.defaultHud.seeText.prozent and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos1Max == 3 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > switchTimer1 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] <= switchTimer2) then
													pos1 = true;
													renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, optimalSize, tostring(txtString));
												end;
											elseif viGui.defaultHud.seeText.fillLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fillLevelTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fillLevelTimer]/2 then
												pos1 = true;
												renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, optimalSize, tostring(txtString));
											end;
										elseif viGui.defaultHud.seeText.fillLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fillLevelTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fillLevelTimer]/2 then
											pos1 = true;
											renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, optimalSize, tostring(txtString));
										end;										
									elseif viGui.defaultHud.seeText.fillLevelPos == 2 and not pos2 then
										if pos2Max > 1 then
											if viGui.defaultHud.seeText.switch then
												if viGui.defaultHud.seeText.switchTimer == -1 or 
												(pos2Max == 2 and viGui.defaultHud.seeText.prozent and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] < viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos2Max == 2 and not viGui.defaultHud.seeText.prozent and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos2Max == 3 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > switchTimer1 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] <= switchTimer2) then
													pos2 = true;
													renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, optimalSize, tostring(txtString));
												end;
											elseif viGui.defaultHud.seeText.fillLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fillLevelTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fillLevelTimer]/2 then
												pos2 = true;
												renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, optimalSize, tostring(txtString));
											end;
										elseif viGui.defaultHud.seeText.fillLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fillLevelTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fillLevelTimer]/2 then
											pos2 = true;
											renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, optimalSize, tostring(txtString));
										end;
									end;
								end;	
							end;							
							txtString = "";
							if viGui.defaultHud.seeText.fruitName then
								fillType = getFillType(self, vehicleStore, true, 5, isMounted, false);							
								if fillType ~= nil and fillType ~= 0 then									
									txtString = fillType;
									if viGui.defaultHud.seeText.fruitNamePos == 1 and not pos1 then
										if pos1Max > 1 then
											if viGui.defaultHud.seeText.switch then
												if viGui.defaultHud.seeText.switchTimer == -1 or 
												(pos1Max == 2 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] < viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos1Max == 3 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > switchTimer2) then
													pos1 = true;
													txtString = getFillType(self, vehicleStore, true, 5, isMounted, false);
													renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, sizeHeightSmall, tostring(txtString));
												end;
											elseif viGui.defaultHud.seeText.fruitNameTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fruitNameTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fruitNameTimer]/2 then
												pos1 = true;
												txtString = getFillType(self, vehicleStore, true, 5, isMounted, false);
												renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, sizeHeightSmall, tostring(txtString));
											end;
										elseif viGui.defaultHud.seeText.fillLevelTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fruitNameTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fruitNameTimer]/2 then
											pos1 = true;
											txtString = getFillType(self, vehicleStore, true, 5, isMounted, false);
											renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix4, sizeHeightSmall, tostring(txtString));
										end;										
									elseif viGui.defaultHud.seeText.fruitNamePos == 2 and not pos2 then
										if pos2Max > 1 then
											if viGui.defaultHud.seeText.switch then
												if viGui.defaultHud.seeText.switchTimer == -1 or 
												(pos2Max == 2 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] < viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.switchTimer]/2) or 
												(pos2Max == 3 and viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.switchTimer] > switchTimer2) then
													pos2 = true;
													txtString = getFillType(self, vehicleStore, true, 5, isMounted, false);
													renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
												end;
											elseif viGui.defaultHud.seeText.fruitNameTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fruitNameTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fruitNameTimer]/2 then
												pos2 = true;
												txtString = getFillType(self, vehicleStore, true, 5, isMounted, false);
												renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
											end;
										elseif viGui.defaultHud.seeText.fruitNameTimer == -1 or viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fruitNameTimer] > viGui.defaultHud.timer["timer".. viGui.defaultHud.seeText.fruitNameTimer]/2 then
											pos2 = true;
											txtString = getFillType(self, vehicleStore, true, 5, isMounted, false);
											renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
										end;
									end;
									
									--if viGui.defaultHud.seeFillLevel or viGui.defaultHud.seeProzent then 
									--	renderText(posX+iconWidthNew+distanceFix2, posY+distanceFix1, sizeHeightSmall, tostring(txtString));
									--else
									--	renderText(posX+iconWidthNew+distanceFix2, posY+(height2)+distanceFix3, sizeHeightSmall, tostring(txtString));
									--end;
								end;	
							end;						
						--else							
						--	setTextColor(unpack(viGui.defaultHud.warningColor4));
						--	renderText(posX+iconWidth+(width*foundAttached), posY+height3, sizeHeightSmall, tostring(getVehicleLenghtName(vehicle, 5)));
						--end;
					end;					
					if not viGui.defaultHud.viewRealAttached then setStoreItem(vehicle,iconWidth, false, true);else foundAttached = 0;end;
					if vehicle.viAttachedTable ~= nil and vehicle.viAttachedTable.isAttached then						
						if vehicle.viAttachedTable.frontAttached or vehicle.viAttachedTable.hardAttached then
							for key,value in pairs(vehicle.viAttachedTable.hardAttached) do							
								if vehicle.viAttachedTable.hardAttached[key] ~= nil and g_currentMission.nodeToVehicle[value] ~= nil then									
									setStoreItem(g_currentMission.nodeToVehicle[value],iconWidth+(width*foundAttached), true, true);
									if isControlledClientPlayer and getSelectable(self, g_currentMission.nodeToVehicle[value]) then
										viGui:setOverlay(self, viGui["select"], posX+iconWidth+(width*foundAttached), posY-distanceFix1, width, false);
										viGui["select"]:render();
									end;
									foundAttached = foundAttached+1;
								end;
							end;
							for key,value in pairs(vehicle.viAttachedTable.frontAttached) do
								if vehicle.viAttachedTable.frontAttached[key] ~= nil and g_currentMission.nodeToVehicle[value] ~= nil then									
									setStoreItem(g_currentMission.nodeToVehicle[value],iconWidth+(width*foundAttached), true, true);
									if isControlledClientPlayer and getSelectable(self, g_currentMission.nodeToVehicle[value]) then
										viGui:setOverlay(self, viGui["select"], posX+iconWidth+(width*foundAttached), posY-distanceFix1, width, false);
										viGui["select"]:render();
									end;
									foundAttached = foundAttached+1;
								end;
							end;
						end;
						if viGui.defaultHud.viewRealAttached then setStoreItem(vehicle,iconWidth+(width*foundAttached), nil, true);foundAttached = foundAttached+1;end;
						if vehicle.viAttachedTable.backAttached then
							for key,value in pairs(vehicle.viAttachedTable.backAttached) do	
								if vehicle.viAttachedTable.backAttached[key] ~= nil and g_currentMission.nodeToVehicle[value] ~= nil then
									setStoreItem(g_currentMission.nodeToVehicle[value],iconWidth+(width*foundAttached), true, true);
									if isControlledClientPlayer and getSelectable(self, g_currentMission.nodeToVehicle[value]) then
										viGui:setOverlay(self, viGui["select"], posX+iconWidth+(width*foundAttached), posY-distanceFix1, width, false);
										viGui["select"]:render();
									end;
									foundAttached = foundAttached+1;
								end;
							end;
						end;
						if viGui.defaultHud.bigbagAttached and vehicle.viAttachedTable.mountedAttached then
							for key,value in pairs(vehicle.viAttachedTable.mountedAttached) do	
								if vehicle.viAttachedTable.mountedAttached[key] then
									local mountedStoreItem = value;
									if mountedStoreItem ~= nil then 
										setStoreItem(mountedStoreItem,iconWidth+(width*foundAttached), true, false, true);									
										foundAttached = foundAttached+1;
									end;
								end;
							end;
						end;
					elseif viGui.defaultHud.viewRealAttached then 
						setStoreItem(vehicle,iconWidth, false, true);
					end;					
					if not firstLine and not upDisplay then nextDesignLine(true, false, newGroup);firstLine = true;end;
					local isBlockedAndName, color = viDraw:getVehicleIsBlockedByControlled(self, vehicle);
					local attachedReadyIcon = false;
					if isControlledClientPlayer then
						attachedReadyIcon = getAttachedReady(self, vehicle, vehicle.controllerShortName);
						viGui:setOverlay(self, viGui["player"], posX+designGround.width, posY+distanceFix1, false, false);
						viGui:setBackgroundColor(self, viGui["player"], viExtras.colors["ls15"]);
						if getPlayerIcon(self, vehicle, "P") then 
							viGui["player"]:render();
							viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+designGround.width, posX+designGround.width+iconWidth, posY+distanceFix1, posY+distanceFix1+(height2), vehicle=vehicle, what="playerName", getTxt="You ".. tostring(vehicle.controllerName)};
						end;
						local nextExtraIcon = 0;
						if attachedReadyIcon then
							viGui:setOverlay(self, viGui["attached"], posX+designGround.width-width, posY, false, false);
							viGui["attached"]:render();
						else
							setExtraIcon(vehicle, isBlockedAndName, color);
						end;
						if string.find(vehicle.controllerShortName, "H") then
							viGui:setOverlay(self, viGui["player"], posX+designGround.width+iconWidth-distanceFix2, posY+distanceFix1, false, false);
							viGui:setOverlay(self, viGui["followMe"], posX+designGround.width+iconWidth-distanceFix2, posY+distanceFix1, false, false);														
							local controllerName = "";
							if viGui.defaultHud.helperName and vehicle.currentHelper ~= nil then controllerName = " (".. tostring(Utils.getNoNil(vehicle.currentHelper.name, "Unknown")).. ")";end;
							if string.len(isBlockedAndName) > 0 then
								setTextColor(unpack(color));
								renderText(posX+designGround.width+(iconWidth*2)+distanceFix1, posY+distanceFix1, sizeHeightSmall, tostring(isBlockedAndName).. tostring(controllerName));
							else
								setTextColor(unpack(color));
								renderText(posX+designGround.width+(iconWidth*2)+distanceFix1, posY+distanceFix1, sizeHeightSmall, tostring(controllerName));
							end;
							if string.find(vehicle.controllerShortName, "HC") then
								viGui:setBackgroundColor(self, viGui["player"], viGui.defaultHud.warningColor2);
								viGui:setBackgroundColor(self, viGui["followMe"], viGui.defaultHud.warningColor2);
							else
								viGui:setBackgroundColor(self, viGui["player"], viExtras.colors["darkGreen"]);
								viGui:setBackgroundColor(self, viGui["followMe"], viExtras.colors["darkGreen"]);
							end;
							if string.find(vehicle.controllerShortName, "HF") then
								if getPlayerIcon(self, vehicle, "H") then 
									viGui["followMe"]:render();
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+designGround.width, posX+designGround.width+iconWidth, posY+distanceFix1, posY+distanceFix1+(height2), vehicle=vehicle, what="hiredName", getTxt="Helper ".. tostring(controllerName)};
								end;
							else
								if getPlayerIcon(self, vehicle, "H") then 
									viGui["player"]:render();
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+designGround.width, posX+designGround.width+iconWidth, posY+distanceFix1, posY+distanceFix1+(height2), vehicle=vehicle, what="hiredName", getTxt="Helper ".. tostring(controllerName)};
								end;
							end;
						else
							if not VehicleInspector.isMp and not masterVehicle.isVehicleSaved and string.len(isBlockedAndName) > 0 then
								setTextColor(unpack(color));
								renderText(posX+designGround.width+(iconWidth)+distanceFix1, posY+distanceFix1, sizeHeightSmall, tostring(isBlockedAndName));
							end;
						end;
					else						
						local nextIcon = 0;
						if string.find(vehicle.controllerShortName, "AP") then
							attachedReadyIcon = getAttachedReady(self, vehicle, vehicle.controllerShortName);
							viGui:setOverlay(self, viGui["player"], posX+designGround.width, posY+distanceFix1, false, false);
							viGui:setBackgroundColor(self, viGui["player"], viExtras.colors["ls15Disabled"]);							
							if getPlayerIcon(self, vehicle, "AP") then
								viGui["player"]:render();
								viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+designGround.width, posX+designGround.width+iconWidth, posY+distanceFix1, posY+distanceFix1+(height2), vehicle=vehicle, what="foreignPlayerName", getTxt="Player ".. tostring(vehicle.controllerName)};
								nextIcon = iconWidth;
							end;
						end;
						if attachedReadyIcon then
							viGui:setOverlay(self, viGui["attached"], posX+designGround.width-width, posY, false, false);
							viGui["attached"]:render();
						else
							setExtraIcon(vehicle, isBlockedAndName, color);
						end;
						if string.find(vehicle.controllerShortName, "H") then						
							viGui:setOverlay(self, viGui["player"], posX+designGround.width+nextIcon, posY+distanceFix1, false, false);
							viGui:setOverlay(self, viGui["followMe"], posX+designGround.width+nextIcon, posY+distanceFix1, false, false);
							local controllerName = "";
							if viGui.defaultHud.helperName and vehicle.currentHelper ~= nil then controllerName = " (".. tostring(Utils.getNoNil(vehicle.currentHelper.name, "Unknown")).. ")";end;
							if string.len(isBlockedAndName) > 0 then
								setTextColor(unpack(color));								
								renderText(posX+designGround.width+iconWidth+(nextIcon)+distanceFix1, posY+distanceFix1, sizeHeightSmall, tostring(isBlockedAndName).. tostring(controllerName));
							else
								setTextColor(unpack(color));
								renderText(posX+designGround.width+iconWidth+(nextIcon)+distanceFix1, posY+distanceFix1, sizeHeightSmall, tostring(controllerName));
							end;
							if string.find(vehicle.controllerShortName, "HC") then
								viGui:setBackgroundColor(self, viGui["player"], viGui.defaultHud.warningColor2);
								viGui:setBackgroundColor(self, viGui["followMe"], viGui.defaultHud.warningColor2);
							else
								viGui:setBackgroundColor(self, viGui["player"], viExtras.colors["darkGreen"]);
								viGui:setBackgroundColor(self, viGui["followMe"], viExtras.colors["darkGreen"]);
							end;
							if string.find(vehicle.controllerShortName, "HF") then
								if getPlayerIcon(self, vehicle, "H") then 
									viGui["followMe"]:render();
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+designGround.width, posX+designGround.width+iconWidth, posY+distanceFix1, posY+distanceFix1+(height2), vehicle=vehicle, what="hiredName", getTxt="Helper ".. tostring(controllerName)};
								end;
							else
								if getPlayerIcon(self, vehicle, "H") then 
									viGui["player"]:render();
									viGui.defaultHud.clickArea[#viGui.defaultHud.clickArea+1] = {posX+designGround.width, posX+designGround.width+iconWidth, posY+distanceFix1, posY+distanceFix1+(height2), vehicle=vehicle, what="hiredName", getTxt="Helper ".. tostring(controllerName)};
								end;
							end;
						else
							isBlockedAndName, color = viDraw:getVehicleIsBlocked(self, vehicle);
							if string.len(isBlockedAndName) > 0 then
								setTextColor(unpack(color));
								renderText(posX+designGround.width+nextIcon+distanceFix1, posY+distanceFix1, sizeHeightSmall, tostring(isBlockedAndName));
							end;
						end;
					end;
					nextPosY(height);
				else
					masterVehicle = nil;
				end;
				--end;
			else
				masterVehicle = nil;
			end;
		end;
		if viGui.defaultHud.vehicleSettingsKeySelect.keyPos > viGui.defaultHud.vehicleSettingsKeySelect.vehicleCounter then 
			setGetKeySelect(0, nil, true);
		end;
	end;	
	setTextBold(false);
	setTextAlignment(0);
end;

function getPlayerIcon(self, vehicle, what)	
	if what == "P" then
		if viGui.defaultHud.seeControlled.playerTrain and vehicle.viVehicleName == "Train" then return true;end;
		if viGui.defaultHud.seeControlled.playerCrane and vehicle.viVehicleName == "Crane" then return true;end;
		if viGui.defaultHud.seeControlled.playerHeli and vehicle.viVehicleName == "Heli" then return true;end;
		if viGui.defaultHud.seeControlled.player and vehicle.viVehicleName ~= "Heli" and vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" then return true;end;
	elseif what == "AP" then
		if viGui.defaultHud.seeControlled.foreignPlayerTrain and vehicle.viVehicleName == "Train" then return true;end;
		if viGui.defaultHud.seeControlled.foreignPlayerCrane and vehicle.viVehicleName == "Crane" then return true;end;
		if viGui.defaultHud.seeControlled.foreignPlayerHeli and vehicle.viVehicleName == "Heli" then return true;end;
		if viGui.defaultHud.seeControlled.foreignPlayer and vehicle.viVehicleName ~= "Heli" and vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" then return true;end;
	elseif what == "H" or what == "HC" or what == "HF" then
		if viGui.defaultHud.seeControlled.hiredTrain and vehicle.viVehicleName == "Train" then return true;end;
		if viGui.defaultHud.seeControlled.hired and vehicle.viVehicleName ~= "Train" then return true;end;
	end;
	return false;
end;

function viDraw:getVehicleIsBlocked(self, vehicle)
	local isBlocked = "";
	local color = viGui.defaultHud.warningColor1;
	if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then
		if vehicle.debugTexts ~= nil and #vehicle.debugTexts > 0 then
			if vehicle.debugTexts[1] ~= nil and string.find(vehicle.debugTexts[1], "STOP") and string.find(vehicle.debugTexts[1], "collision") then		
				return "! Collision !", viGui.defaultHud.warningColor3;		
			end;	
		end;
	end;
	if vehicle.viValue ~= nil and string.len(vehicle.viValue.globalWarning.warningTxt) <= 0 then return isBlocked, color;end;
	if vehicle.isBroken	and vehicle.showWaterWarning then
		return "! Damage (Water) !", viGui.defaultHud.warningColor3;
	elseif vehicle.isBroken	then
		return "! Damage !", viGui.defaultHud.warningColor3;	
	elseif vehicle.showWaterWarning	then
		return "! Water !", viGui.defaultHud.warningColor3;			
	elseif vehicle.viVehicleName ~= "Train" and vehicle.viVehicleName ~= "Crane" and not VehicleInspector.isMp and not vehicle.isVehicleSaved then
		return "! Field Mission !", color;
	elseif vehicle.isAllowedToDrive then
		if vehicle.pipeCurrentState ~= nil and (vehicle.pipeCurrentState == 1 or vehicle.pipeCurrentState == 2) then
			if Utils.getNoNil(vehicle.sendDidOverload,false) or (vehicle.pipeFoundTrailer and vehicle.pipeTargetState == 2 and vehicle.sentPipeFoundTrailer ~= nil) then
				return "! Overloaded !", color;
			end;
		end;
	end;
	return isBlocked, color;
end;

function viDraw:getVehicleIsBlockedByControlled(self, vehicle)
	local isBlocked = "";
	local color = viGui.defaultHud.warningColor1;	
	if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then
		if vehicle.debugTexts ~= nil and #vehicle.debugTexts > 0 then		
			if vehicle.debugTexts[1] ~= nil and string.find(vehicle.debugTexts[1], "STOP") and string.find(vehicle.debugTexts[1], "collision") then		
				return "! Collision !", viGui.defaultHud.warningColor3;
			elseif vehicle.debugTexts[2] ~= nil and string.find(vehicle.debugTexts[2], "Drive straight") then	
				return "At working", color;
			elseif vehicle.didNotMoveTimer > 0 or (vehicle.debugTexts[1] ~= nil and vehicle.autoRotateBackSpeed > 0) or (vehicle.debugTexts[1] ~= nil and vehicle.onAiRotateLeft ~= nil and vehicle.onAiRotateLeft) or (vehicle.debugTexts[1] ~= nil and vehicle.onAiRotateRight ~= nil and vehicle.onAiRotateRight) then		
				return "At working", color;
			end;	
		end;
	end;
	if vehicle.viValue ~= nil and string.len(vehicle.viValue.globalWarning.warningTxt) > 0 then return isBlocked, color;end;
	function getCollision()
		if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then return false;end;
		if vehicle.aiIsStarted then
			if vehicle:getLastSpeed() < 0.5 then 
				vehicle.didNotMoveTimer = vehicle.didNotMoveTimer-10;
			else
				vehicle.didNotMoveTimer = vehicle.didNotMoveTimeout;
			end;
			if vehicle.didNotMoveTimer < 0 then return true;end;
		end;
		return false;
	end;
	if vehicle.isFuelFilling then
		return "Refuel", color;
	elseif not vehicle.isAllowedToDrive and not vehicle.isHirableBlocked then
		if vehicle.pipeCurrentState ~= nil and vehicle.pipeCurrentState == 2 then
			if Utils.getNoNil(vehicle.sendDidOverload,false) or (vehicle.pipeFoundTrailer and vehicle.pipeTargetState == 2 and vehicle.sentPipeFoundTrailer ~= nil) then --and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
				return "! Overloaded !", color;
			elseif not vehicle.combineIsFilling then
				--return "! Wait !"; viGui.defaultHud.warningColor3;			
			end;			
		end;		
	elseif vehicle.isAllowedToDrive then
		if vehicle.pipeCurrentState ~= nil and (vehicle.pipeCurrentState == 1 or vehicle.pipeCurrentState == 2) then
			if Utils.getNoNil(vehicle.sendDidOverload,false) or (vehicle.pipeFoundTrailer and vehicle.pipeTargetState == 2 and vehicle.sentPipeFoundTrailer ~= nil) then
				isBlocked = "! Overloaded !";
			elseif (vehicle.pipeCurrentState ~= 1 and not vehicle.combineIsFilling and vehicle:getLastSpeed() == 0) or (vehicle.pipeCurrentState == 2 and vehicle:getLastSpeed() == 0) then
				--isBlocked = "! Wait !"; color = viGui.defaultHud.warningColor3;
			end;
		end;
		if string.len(isBlocked) <= 0 and getCollision() then isBlocked = "! Stand still  !"; color = viGui.defaultHud.warningColor3;end;
		if string.len(isBlocked) > 0 then
			return isBlocked, color;
		elseif VehicleInspector.isMp and not VehicleInspector.loadHostServer then			
			return "At working", color;			
		end;		
	end;
	return isBlocked, color;
end;

function viDraw:getVehicleIsBlockedByControlledOld(self, vehicle)
	local isBlocked = "";
	local color = viGui.defaultHud.warningColor1;	
	if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then
		if vehicle.debugTexts ~= nil and #vehicle.debugTexts > 0 then		
			if vehicle.debugTexts[1] ~= nil and string.find(vehicle.debugTexts[1], "STOP") and string.find(vehicle.debugTexts[1], "collision") then		
				return "! Collision !", viGui.defaultHud.warningColor3;
			elseif vehicle.debugTexts[2] ~= nil and string.find(vehicle.debugTexts[2], "Drive straight") then	
				return "At working", color;
			elseif vehicle.didNotMoveTimer > 0 or (vehicle.debugTexts[1] ~= nil and vehicle.autoRotateBackSpeed > 0) or (vehicle.debugTexts[1] ~= nil and vehicle.onAiRotateLeft ~= nil and vehicle.onAiRotateLeft) or (vehicle.debugTexts[1] ~= nil and vehicle.onAiRotateRight ~= nil and vehicle.onAiRotateRight) then		
				return "Turn round", color;
			end;	
		end;
	end;
	if vehicle.viValue ~= nil and vehicle.viValue.globalWarning.isWarning then return isBlocked, color;end;
	function getCollision()
		if not VehicleInspector.isMp or (VehicleInspector.isMp and VehicleInspector.loadHostServer) then return false;end;
		if vehicle.aiIsStarted then
			if vehicle:getLastSpeed() < 0.5 then 
				if vehicle.didNotMoveTimer == 5000 then vehicle.didNotMoveTimer = vehicle.didNotMoveTimer-10;end;
			else
				vehicle.didNotMoveTimer = vehicle.didNotMoveTimeout;
			end;
			if vehicle.didNotMoveTimer < 0 then return true;end;
		end;
		return false;
	end;
	if vehicle.isBroken	and vehicle.showWaterWarning then
		return "! Damage (Water) !", viGui.defaultHud.warningColor3;
	elseif vehicle.isBroken	then
		return "! Damage !";	
	elseif vehicle.showWaterWarning	then
		return "! Water !", viGui.defaultHud.warningColor3;
	elseif (vehicle.getIsCourseplayDriving ~= nil and vehicle:getIsCourseplayDriving() and (vehicle.cp ~= nil and vehicle.cp.wait)) then
		return "! Wait(CP) !", viGui.defaultHud.warningColor3;	
	elseif vehicle.isFuelFilling then
		return "Refuel", color;
	elseif not vehicle.isAllowedToDrive and not vehicle.isHirableBlocked then
		if vehicle.pipeCurrentState ~= nil and vehicle.pipeCurrentState == 2 then
			if Utils.getNoNil(vehicle.sendDidOverload,false) then --Utils.getNoNil(vehicle.sentPipeFoundTrailer,false) and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
				return "! Overloaded !", color;
			elseif not vehicle.combineIsFilling then
				return "! Wait (Full) !", viGui.defaultHud.warningColor3;			
			end;
		--elseif vehicle.pipeCurrentState ~= nil and vehicle.pipeCurrentState == 1 then
		--	if Utils.getNoNil(vehicle.sendDidOverload,false) or not vehicle.combineIsFilling then --Utils.getNoNil(vehicle.sentPipeFoundTrailer,false) and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
		--		return "! Almost Full !";						
		--	end;
		elseif not vehicle.viValue.isSeedsOrSprayer and tonumber(Utils.getNoNil(vehicle.viValue.fillLevelProzent,0)) >= 100 then
			return "! Full !", viGui.defaultHud.warningColor3;
		elseif vehicle.viValue.isSeedsOrSprayer and tonumber(Utils.getNoNil(vehicle.viValue.fillLevelProzent),100) <= 0 then
			return "! Empty !", viGui.defaultHud.warningColor3;
		elseif not VehicleInspector.isMp and not vehicle.isVehicleSaved then
			return "! Field Mission !", color;	
		end;		
	elseif vehicle.isAllowedToDrive then		
		if not VehicleInspector.isMp and not vehicle.isVehicleSaved then
			isBlocked = "! Field Mission !";
		end;
		if string.len(isBlocked) <= 0 and not vehicle.viValue.isSeedsOrSprayer and tonumber(Utils.getNoNil(vehicle.viValue.fillLevelProzent,0)) >= 100 then
			isBlocked = "! Full !";
		--elseif not vehicle.viValue.isSeedsOrSprayer and tonumber(Utils.getNoNil(vehicle.viValue.fillLevelProzent,0)) >= 90 and tonumber(Utils.getNoNil(vehicle.viValue.fillLevelProzent,0)) < 100 then
		--	isBlocked = "! Almost Full !", viGui.defaultHud.warningColor3;
		end;
		if string.len(isBlocked) <= 0 and vehicle.viValue.isSeedsOrSprayer and tonumber(Utils.getNoNil(vehicle.viValue.fillLevelProzent),100) <= 0 then
			isBlocked = "! Empty !";		
		end;
		if string.len(isBlocked) <= 0 and vehicle.pipeCurrentState ~= nil and (vehicle.pipeCurrentState == 1 or vehicle.pipeCurrentState == 2) then
			if Utils.getNoNil(vehicle.sendDidOverload,false) or not vehicle.combineIsFilling and vehicle.lastSpeed <= 0 then --Utils.getNoNil(vehicle.sentPipeFoundTrailer,false) and Utils.getNoNil(vehicle.trailerFound,0) > 0 and Utils.getNoNil(vehicle.sendDidOverload,false) then
				isBlocked = "! Wait !";					
			end;
		end;
		--if string.len(isBlocked) <= 0 and getCollision() then isBlocked = "! Collision  !";end;
		if string.len(isBlocked) > 0 then
			return isBlocked, viGui.defaultHud.warningColor3;
		elseif VehicleInspector.isMp and not VehicleInspector.loadHostServer then			
			return "At working", color;			
		end;
	elseif not VehicleInspector.isMp and not vehicle.isVehicleSaved then
		return "! Field Mission !", color;	
	elseif vehicle.isHirableBlocked then
		return "! Hired Blocked !", viGui.defaultHud.warningColor3;		
	end;
	return isBlocked, color;
end;

function getVehicleLenghtName(vehicle, length)
	local toLong = "";
	local vehicleName = Utils.getNoNil(vehicle.viVehicleName, "Unknown");
	if string.len(vehicleName) > tonumber(length) then toLong = ".";end;
	return utf8Substr(vehicleName, 0, length).. tostring(toLong);
end;

function getSpeed(self, vehicle)
	local speed = Utils.getNoNil(vehicle.lastSpeed, 0)*3600; --lastSpeed,speedDisplayDt	
	if vehicle.viVehicleName == "Train" then speed = Utils.getNoNil(vehicle.speed, 0)*3.6;end;
	return string.format("%1.0f", "".. Utils.getNoNil(speed, 0));
end;

function getIsOnField(self, vehicle)
    local fieldNumber = "";
	if vehicle.components ~= nil and vehicle.components[1] ~= nil and vehicle.components[1].node ~= nil then					
		local wx,_,wz = getWorldTranslation(vehicle.components[1].node);
		if wx~=wx or wz~=wz then
			return fieldNumber;
		end;
		
		if viFieldDef == nil or table.getn(viFieldDef) <= 0 then return fieldNumber;end;
		for fieldNum,fieldDef in ipairs(viFieldDef) do
			for _,tableValues in ipairs(fieldDef) do
				if tableValues.x1 <= wx and wx <= tableValues.x2 and tableValues.z1 <= wz and wz <= tableValues.z2 then									
					local wX, wZ, wWX, wWZ, wHX, wHZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, wx, wz, tableValues.x1, tableValues.z1, tableValues.x2, tableValues.z2);
					--ls17
					local wXX,wYY,wZZ = 0,0,0;
					if vehicle.components ~= nil and vehicle.components[1] ~= nil and vehicle.components[1].node ~= nil then
						wXX,wYY,wZZ = getWorldTranslation(vehicle.components[1].node);
					end;
					local foundField = getDensityAtWorldPos(g_currentMission.terrainDetailId, wX, wYY, wZ);
					if foundField == nil or foundField <= 0 then break;end;
					fieldNumber = fieldNum;
					break;
				end;
			end;
			if fieldNumber ~= 0 and fieldNumber ~= "" then break;end;
		end;
	end;
	return fieldNumber;	
end;

function getFillType(self, vehicle, getFillTypeName, maxLength, isMounted, fullName)
	local fillType = nil;
	if vehicle.viVehicleName == "Train" then return fillType;end;
	if isMounted then 		
		fillType = vehicle.fillType;		
	end;
	if vehicle.getUnitFillType ~= nil or fillType ~= nil then
		if fillType == nil then fillType = vehicle:getUnitFillType(1);end;
		if fillType ~= nil and fillType ~= 0 and getFillTypeName then
			local desc = FillUtil.fillTypeIndexToDesc[fillType];
			local descSeeds = FillUtil.fillTypeIndexToDesc[Utils.getNoNil(FruitUtil.fruitTypeToFillType[vehicle.viValue.fill.seedsFruit], 0)];
			local descSprayer = FillUtil.fillTypeIndexToDesc[vehicle.viValue.fill.sprayerFruit];			
			local fillTypeName = "";
			local fillTypeNameFill = "";
			local fillTypeNameSeeds = "";
			local fillTypeNameSprayer = "";
			if desc ~= nil then				
				if desc.nameI18N ~= nil then 
					fillTypeNameFill = desc.nameI18N;
				elseif desc.name ~= nil then
					fillTypeNameFill = desc.name;
				end;
			end;
			if vehicle.viValue.fill.combineFill then
				if descSeeds ~= nil and descSeeds ~= 0 then				
					if descSeeds.nameI18N ~= nil then 
						fillTypeNameSeeds = descSeeds.nameI18N;
					elseif descSeeds.name ~= nil then
						fillTypeNameSeeds = descSeeds.name;
					end;
				end;
				if descSprayer ~= nil and descSprayer ~= 0 then				
					if descSprayer.nameI18N ~= nil then 
						fillTypeNameSprayer = descSprayer.nameI18N;
					elseif descSprayer.name ~= nil then
						fillTypeNameSprayer = descSprayer.name;
					end;
				end;
			end;
			fillTypeName = fillTypeNameFill;
			if (fullName and vehicle.viValue.fill.combineFill) or (not fullName and vehicle.viValue.fill.combineFill and viGui.defaultHud.seedsSprayerFillTxt.isType == 2) then
				if string.len(fillTypeName) <= 0 then fillTypeName = "CB";end;
				if string.len(fillTypeNameSeeds) > 0 then fillTypeName = fillTypeName.. "(".. fillTypeNameSeeds.. ")";end;
				if string.len(fillTypeNameSprayer) > 0 then fillTypeName = fillTypeName.. "/".. fillTypeNameSprayer;end;
				if fullName then fillType = getFillTypeNameString(fillTypeName, maxLength);end;
			elseif not fullName and not vehicle.viValue.fill.combineFill then
				fillType = getFillTypeNameString(fillTypeName, maxLength);
			end;			
			if not fullName and vehicle.viValue.fill.combineFill and viGui.defaultHud.seedsSprayerFillTxt.isType == 0 then --no switch
				fillType = getFillTypeNameString(fillTypeName, maxLength);
			elseif not fullName and vehicle.viValue.fill.combineFill and viGui.defaultHud.seedsSprayerFillTxt.isType == 1 then --blinkTxt
				if viGui.defaultHud.seedsSprayerFillTxt.isLetter > 2 then viGui.defaultHud.seedsSprayerFillTxt.isLetter = 0;end;				
				-- viGui.defaultHud.timer["isTimer".. viGui.defaultHud.seeText.fruitNameTimer] --prüfen ob im interval
				viGui.defaultHud.seedsSprayerFillTxt.timer = viGui.defaultHud.seedsSprayerFillTxt.timer+1
				if viGui.defaultHud.seedsSprayerFillTxt.timer > viGui.defaultHud.seedsSprayerFillTxt.isTimer then
					viGui.defaultHud.seedsSprayerFillTxt.isLetter = viGui.defaultHud.seedsSprayerFillTxt.isLetter+1;
					viGui.defaultHud.seedsSprayerFillTxt.timer = 0;
				end;
				if viGui.defaultHud.seedsSprayerFillTxt.isLetter == 0 then
					fillType = fillTypeNameFill;
				elseif viGui.defaultHud.seedsSprayerFillTxt.isLetter == 1 then
					fillTypeName = fillTypeNameSeeds;
				elseif viGui.defaultHud.seedsSprayerFillTxt.isLetter == 2 then
					fillTypeName = fillTypeNameSprayer;	
				end;
				if string.len(fillTypeName) <= 0 then fillTypeName = fillTypeNameFill;end;
				fillType = getFillTypeNameString(fillTypeName, maxLength);
				--if viGui.defaultHud.timer["isTimer2"] > viGui.defaultHud.timer["timer2"]/2 then					
				--	if string.len(fillTypeNameSeeds) > 0 and string.len(fillTypeNameSprayer) > 0 then
				--		if viGui.defaultHud.timer["isTimer1"] > viGui.defaultHud.timer["timer1"]/2 then	
				--			fillTypeName = fillTypeNameSprayer;
				--		elseif viGui.defaultHud.timer["isTimer1"] < viGui.defaultHud.timer["timer1"]/2 then							
				--			fillTypeName = fillTypeNameSeeds;
				--		end;
				--	else
				--		if string.len(fillTypeNameSeeds) > 0 then 
				--			fillTypeName = fillTypeNameSeeds;
				--		elseif string.len(fillTypeNameSprayer) > 0 then 
				--			fillTypeName = fillTypeNameSprayer;	
				--		end;
				--	end;					
				--	if string.len(fillTypeName) <= 0 then fillTypeName = fillTypeNameFill;end;
				--	fillType = getFillTypeNameString(fillTypeName, maxLength);
				--elseif viGui.defaultHud.timer["isTimer2"] < viGui.defaultHud.timer["timer2"]/2 then
				--	fillType = getFillTypeNameString(fillTypeName, maxLength);					
				--end;
			elseif not fullName and vehicle.viValue.fill.combineFill and viGui.defaultHud.seedsSprayerFillTxt.isType == 2 then --runningTxt
				if viGui.defaultHud.seedsSprayerFillTxt.isLetter > string.len(tostring(fillTypeName)) then subLength = 0;viGui.defaultHud.seedsSprayerFillTxt.isLetter=0;end;
				subLength = viGui.defaultHud.seedsSprayerFillTxt.isLetter;
				viGui.defaultHud.seedsSprayerFillTxt.timer = viGui.defaultHud.seedsSprayerFillTxt.timer+1 
				if viGui.defaultHud.seedsSprayerFillTxt.timer > viGui.defaultHud.seedsSprayerFillTxt.isTimer then
					viGui.defaultHud.seedsSprayerFillTxt.isLetter = viGui.defaultHud.seedsSprayerFillTxt.isLetter+1;
					viGui.defaultHud.seedsSprayerFillTxt.timer = 0;
				end;								
				fillType = getFillTypeNameString(fillTypeName, maxLength+1, subLength);
			end;		
		end;
	end;
	return fillType;
end;

function getFillTypeNameString(fillTypeName, maxLength, runningSubLength)
	local toLong = "";
	subLength = 0;
	if runningSubLength ~= nil then
		return utf8Substr(tostring(fillTypeName), runningSubLength, maxLength);
	end;
	if runningSubLength == nil and string.len(tostring(fillTypeName)) > tonumber(maxLength) then toLong = ".";end;
	return utf8Substr(tostring(fillTypeName), subLength, maxLength).. tostring(toLong);	
end;

function getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = viGui.buttonGfxHeight1*viGui.defaultHud.zoomOutIn;
	if length > width then
		local i = 0.05;
		while length > width do
			i = i + 0.05;
			length = getTextWidth(default*(2.7-i), tostring(txtString));
		end
		return default*(2.7-i);
	end;
	return nil;
end;

function getAttachedReady(self, vehicle, shortName)	
	if not viGui.defaultHud.seeExtraIcon.isDraw then return false;end;
	if g_currentMission.attachableInMountRange ~= nil then
        if g_currentMission.attachableInMountRangeVehicle == vehicle then
            if vehicle.attacherJoints[g_currentMission.attachableInMountRangeIndex].jointIndex == 0 then                
                if viGui.defaultHud.seeExtraIcon.attachedAllReady then return true;
				elseif string.find(shortName, "P") and not string.find(shortName, "AP") and viGui.defaultHud.seeExtraIcon.attachedPlayerReady then return true;
				elseif string.find(shortName, "AP") and viGui.defaultHud.seeExtraIcon.attachedForeignPlayerReady then return true;end;
            end;
        else
            for _,implement in ipairs(vehicle.attachedImplements) do
                if implement.object ~= nil then --and Utils.getNoNil(implement.object:handleAttachAttachableEvent(), false) then
                    if viGui.defaultHud.seeExtraIcon.attachedAllReady then return true;
					elseif string.find(shortName, "P") and not string.find(shortName, "AP") and viGui.defaultHud.seeExtraIcon.attachedPlayerReady then return true;
					elseif string.find(shortName, "AP") and viGui.defaultHud.seeExtraIcon.attachedForeignPlayerReady then return true;end;
                end;
            end;
        end;
    end;
	return false;	
end;

function getSelectable(self, vehicle)	
	if Utils.getNoNil(vehicle.isSelected, false) and viGui.defaultHud.seeExtraIcon.isDraw and viGui.defaultHud.seeExtraIcon.selectedVehicle then return true;end;
	return false;
end;

function viDraw:isVehicleClientPlayer(self, vehicle)	
	return vehicle.isControlled and vehicle.controllerName == g_currentMission.player.controllerName;
end;

function getDesignGroundAndLine(self)
	local designGround = viGui["designGroundNo"];
	local designLine = viGui["designLineNo"];
	local designMarker = viGui["designMarker"];
	viGui:setBackgroundColor(self, designMarker, viExtras.colors[viGui.defaultHud.colorName[viGui.defaultHud.vehicleSettingsKeySelect.color]]);
	local designGroupLine = viGui["designGroupLine"];
	local colorNameGround = viGui.defaultHud.designGroundColor[viGui.defaultHud.designGroundColorMarker];
	local colorNameGroundLine = viGui.defaultHud.designGroundColor[viGui.defaultHud.designGroundLineColorMarker];
	if viGui.defaultHud.designGroundType == 1 then --transparent
		designGround = viGui["designGroundT"];
		designLine = viGui["designLineT"];		
		viGui:setBackgroundColor(self, designGround, viExtras.colors[colorNameGround .."Disabled"]);
		if viGui.defaultHud.designGroundTransparent < 0.75 then
			viGui:setBackgroundColor(self, designGround, {viExtras.colors[colorNameGround .."Disabled"][1],viExtras.colors[colorNameGround .."Disabled"][2],viExtras.colors[colorNameGround .."Disabled"][3],viGui.defaultHud.designGroundTransparent});
		end;
		viGui:setBackgroundColor(self, designLine, viExtras.colors[colorNameGroundLine.."Inactive"]);		
	elseif viGui.defaultHud.designGroundType == 2 then --no transparent
		designGround = viGui["designGround"];
		designLine = viGui["designLine"];		
		viGui:setBackgroundColor(self, designGround, viExtras.colors[colorNameGround]);		
		viGui:setBackgroundColor(self, designLine, viExtras.colors[colorNameGroundLine]);
	end;	
	return designGround, designLine, designGroupLine, designMarker;
end;